Subject: Re: bug#55412: 28.1; In Emacs 28.1, using ':eval' in 'frame-title-format' doesn't work properly

From: Eli Zaretskii <[email-masked]>
Date: Fri, 20 May 2022 13:58:45 +0300

> Date: Fri, 20 May 2022 10:23:17 +0200
> Cc: [email-masked], [email-masked]
> From: martin rudalics <[email-masked]>
> 
>  > It would be good to have some of these explanations in comments there.
> 
> I understand that we want a quick solution for the present bug so it can
> be included in Emacs 28.2.  But I still don't understand why nobody even
> cared to try the patch I sent earlier.

I don't think I understand what patch that is, but we could install
different solutions on master and the release branches.

In general, I prefer the old code to a new one, because the old code
by definition keeps old behavior, and thus runs lower risks of
breaking something.  But I won't object installing what is deemed a
better solution on master, even though it is riskier.

> With the current code, whenever there are at least two frames
> present, 'gui_consider_frame_title' calls via Fselect_window among
> others
> 
> redisplay_other_windows
> 
> Fredirect_frame_focus
> 
> resize_mini_window
> 
> move_minibuffers_onto_frame
> 
> and sets
> 
> last_nonminibuf_frame
> 
> internal_last_event_frame
> 
> Has anyone ever tried to understand the implications of all these?

Why would we need to do that?  This code was there for many years, so
its effects are by now a de-facto standard behavior of Emacs.  We
don't have human power and resources to revisit those decisions unless
someone submits a bug report, or unless some deep refactoring or
reimplementation of the code is taking place.

> When trying to fix Bug#32777 I spent some time investigating these
> issues but never found out why on earth we should call routines like
> 'select-frame' and 'select-window' from redisplay.

Well, now we know at least one reason: so that referencing
frame-parameters would what Lisp programs expect.